# README

Timeline Whisper

テキスト読み上げソフトを使用してMastodonなどのタイムラインを読み上げるソフトです。



# 動作環境

* Windows 7以上, 2GB以上のメモリ(推奨)
  * Windows以外(たとえばWine上)での動作は確認していません
* 棒読みちゃん0.11以上
  * 0.11未満のバージョンでの動作は確認していません
* Javaランタイム Version 8以上
* WebSocketが使えるネットワーク
  * ルータやファイアーウォールでWebSocketが通る必要があります
  * 該当MastodonサーバでStreaming API(WebSocket(SSL))が使える必要があります



# 導入

1. Java SEのランタイムをインストールしてください
  * https://java.com/ja/download/
2. 棒読みちゃんをインストールしてください
  * http://chi.usamimi.info/Program/Application/BouyomiChan/
  * 適当なディレクトリにアーカイブファイルを展開してください
3. Timeline Whisperをインストールしてください
  * https://cappuccino.jp/keisuken/software/TimelineWhisper/TimelineWhisper-0.1.1.zip
  * 適当なディレクトリにアーカイブファイルを展開してください



# 起動

1. 棒読みちゃんを起動してください
  * BouyomiChan.exe を起動
2. Timeline Whisperを起動してください
  * home.bat, local.bat または public.bat を起動
  * home.bat: ホームタイムライン
  * local.bat: ローカルタイムライン
  * public.bat: 連合タイムライン
  * 初めての場合は、Mastodonやアカウントの情報を入力してください
    * ホストURL(例): https://mastodon.example.com
    * E-Mail(例): foo@example.com
    * パスワード(例): fooboobuzz
    * 入力済みの場合は問い合わせをしません



# 停止

* Timeline Whisperのコマンドプロンプト上で、キーボードでCTRL-Cで停止してください。



# 設定をクリア

* config-clear.batを起動します
* Mastodonのホスト名やE-Mail、パスワードを変更する時に行います
  * Mastodonやアカウントの情報を間違えたり、他のMastodonの設定に切り替えたりする場合に使用します



# FAQ

* GUIは用意していないのですか?
  * 今のところ考えていません
* 棒読みちゃんのPlugin形式での提供はしないのですか?
  * 棒読みちゃん以外への対応も考え、Plugin形式には対応しないことにしました
* 棒読みちゃんを自動的に起動しないのですか?
  * 次のバージョンで対応を考えています
* ソースは公開しないのですか?
  * 今のところ考えていません



# バグ・要望

## バグ

* たまに読まないトゥートがある
  * トゥートのデータ(JSONやHTML)の解析に問題がある
* "Could not open/create prefs root node"と表示される
  * Windows 7でProgram Fileディレクトリに置くとレジストリに書き込めない(Windows 7+Javaランタイムの仕様)
  * 他のディレクトリに移動してください
  * または初回バッチファイルを起動するときに右クリック->管理者として実行をしてください



## 要望

* パスワード入力で*を表示してほしい
  * 他の方法を考慮中



# ToDo

* ソフトの改名
* 通知の読み上げ
* 棒読みちゃん以外(例えば他のSpeech API)の対応
* ブラウザ(Web Speech API)の対応
* Mastodon以外への対応
  * ニコニコ生放送
  * YouTube
  * Ustream
  * Beam.pro



# 履歴

* 0.1.0: 2017-07-27
  * CUI(コマンドプロンプト)による対話環境
  * ローカルとホームのタイムラインを読み上げ
* 0.1.1: 2017-07-28
  * 名称変更
    * 旧: BouyomiChan for Mastodon
    * 新: TimelineWhisper
  * ホームタイムラインの追加
  * トゥートデータ解析の改良
  * 棒読みちゃんの自動起動



# 使用ソフトウェア・ライブラリ

* 棒読みちゃん 0.11
* Javaランタイム Version 8
* Scala
  * Scala 2.11コンパイラ
  * scala-library
  * sca-a-xml
* Caffe Builder 0.3
  * ビルドソフトウェア
* Jsoup 1.10
* Tyrus standalone client



# 著作者

* 西本 圭佑 (NISHIMOTO Keisuke)
* Twitter: @keisuke_n



# ライセンス

[LICENSE](LICENSE.txt)をお読みください。

使用しているライブラリのライセンスについては、[licenses](licenses)をご覧ください。
